#include <fstream>
#include <iostream>
#include <string>
#include <list>

using std::endl;
using std::cout;
using std::cerr;
using std::cin;
using std::ifstream;
using std::string;

typedef std::list<std::string> seznam_jmen;

int main (int argc, char ** argv){


	// nacti jmena
    seznam_jmen jmena;
    string ans;

    {
        ifstream soubor("seznam_jmen.txt", ifstream::in);
        while (soubor.good()){
			string tmp;
			std::getline(soubor, tmp);
			jmena.push_back(tmp);
		}
    }

    if (jmena.empty()){
		cerr << "nelze nacist jmena, koncim" << endl;
		return 1;
	}

    // vypis nactena jmena
	cout << "Nactena jmena: ";
	for (seznam_jmen::const_iterator i = jmena.begin(); i != jmena.end(); i++){
		cout << *i << " ";
	}
	cout << endl;

	// pauza
	cout << "pauza...";
    cin >> ans;

    {
        ifstream soubor("seznam_jmen.txt", ifstream::in);

        while (jmena.size() < 200000){
			while (soubor.good()){
				string tmp;
				std::getline(soubor, tmp);
				jmena.push_back(tmp);
			}
			// pretoc soubor na zacatek a znovu nacitej jmena
			soubor.clear();
			soubor.seekg(0, std::ios_base::beg);
		}
    }
	// pauza
	cout << "pauza...";
    cin >> ans;
    {
		cout << "vypisuji 100000. položku: ";
		seznam_jmen::const_iterator i = jmena.begin();
		for (int j = 0; j < 100000; j++){ i++; }
		cout << *i << endl;
    }
	cout << "pauza...";
    cin >> ans;
    {
		seznam_jmen::iterator i = jmena.begin();
		for (int j = 0; j < 100000; j++){ i++; }
        jmena.insert(i, string("Franta"));
    }
	cout << "pauza...";
    cin >> ans;

    return 0;
}
